<?php

namespace App\Http\Controllers;

use App\Models\Persona;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class PersonaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = Persona::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new Persona())->getFillable());
        $persona = Persona::create($payload);

        return response()->json([
            'success' => true,
            'data' => $persona,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(Persona $persona): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $persona,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Persona $persona): JsonResponse
    {
        $payload = $request->only((new Persona())->getFillable());
        $persona->update($payload);

        return response()->json([
            'success' => true,
            'data' => $persona,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Persona $persona): JsonResponse
    {
        $persona->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}